function [im] = makeMosaic( data )
pixel_gap = 5;

clf;


TimeStep     = 1;


numframe = numel( data );

max_x = 0;
max_y = 0;

for ii = 1:numframe
    
    ss = size(data{ii});
    
    max_x = max( [max_x, ss(2)] );
    max_y = max( [max_y, ss(1)] );
end


nx = ceil( sqrt( numframe*max_y/max_x ) );
ny = ceil( numframe/nx );


max_x = max_x+pixel_gap;
max_y = max_y+pixel_gap;


imdim = [ max_y*ny , max_x*nx  ];
im = zeros(imdim(1), imdim(2));



for ii = 1:numframe
    
    yy = floor((ii-1)/nx);
    xx = ii-yy*nx-1;
    
    ss = size(data{ii});
    
    dx = floor((max_x-ss(2))/2);
    dy = floor((max_y-ss(1))/2);
    
    im(1+yy*max_y+(1:ss(1))+dy, 1+xx*max_x+(1:ss(2))+dx) = data{ii};
    %im(1+yy*max_y+(1:ss(1))+dy, 1+xx*max_x+(1:ss(2))+dx) = 0;  
    
end

imshow( im, [] );

% 
% im = cat( 3, ...
%     del*ag(~mask__)+ag(double(im2_).*(1+2*double(mask__))), ...
%     del*ag(~mask__)+ag(double(im1_).*(1+2*double(mask__))), ...
%     uint8(del*ag(~mask__)+ag(outer)) );
% 
% inv_flag = 0;
% 
% if inv_flag
%     imshow( 255-im );
% else
%     imshow( im );
% end
% 
% 
% hold on;

for ii = 1:numframe
    
    yy = floor((ii-1)/nx);
    xx = ii-yy*nx-1;
    
    y = 1+yy*max_y;
    x = 1+xx*max_x;
    
    
    text( x+2, y+2, num2str(ii),'Color','b','FontSize',12,'VerticalAlignment','Top');
     
     
end
% 
% 
% dd = [1,ny*max_y+1];
% for xx = 1:(nx-1)
%     plot( 0*dd + 1+xx*max_x, dd,':b');
% end
% 
% dd = [1,nx*max_x+1];
% for yy = 1:(ny-1)
%     plot( dd, 0*dd + 1+yy*max_y, ':b');
% end
% 
% end
% 
% 
